### Method

# FwupdPlugin UdevDevice read_sysfs

since: 2.0.0

#### Declaration [src]

    gchar*
    fu_udev_device_read_sysfs (
      FuUdevDevice* self,
      const gchar* attr,
      guint timeout_ms,
      GError** error
    )

#### Description [src]

Reads data from a sysfs attribute, removing any newline trailing chars.

Available since: 2.0.0

#### Parameters

`attr`

  Type: `const gchar*`

  Sysfs attribute name.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`timeout_ms`

  Type: `guint`

  IO timeout in milliseconds.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

String value, or `NULL`.

The caller of the method takes ownership of the data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.